Attribute VB_Name = "modGlobal"
Option Explicit

'******************
'* Global consts: *
'******************

Public Const VERSION_NR    As String = "1.0b"
Public Const HOST_NAME     As String = "ftp1.pixbook.be"
Public Const HOST_IP       As String = "217.22.61.26"
Public Const USER_NAME     As String = "albumsubmit"
Public Const PASS_WORD     As String = "layellow357"
Public Const WEB_REQUEST   As String = "http://extranet.mypersonalstory.be/php/mypersonalstory.php?"

Public Const MM2TW As Single = 1440 / 25.4 'Factor to convert millimeters to twips

Public Const ORIG_TWIPS_X As Integer = 15 'The original number of twips per pixel X (in design mode)
Public Const ORIG_TWIPS_Y As Integer = 15 'The original number of twips per pixel Y (in design mode)

'****************
'* Global vars: *
'****************

Public iTwX            As Integer 'The current twips per pixel X (in run-time mode)
Public iTwY            As Integer 'The current twips per pixel Y (in run-time mode)
Public iPgWd           As Long    'The current (variable) page width (on screen) in twips
Public iPgHt           As Long    'The current (variable) page height (on screen) in twips
Public iPgWdTw         As Long    'The constant page width (on screen) in twips
Public iPgHtTw         As Long    'The constant page height (on screen) in twips
Public iPgWdMm         As Integer 'The constant page width in mm
Public iPgHtMm         As Integer 'The constant page height in mm
Public iPage           As Integer 'The current page number
Public iCover          As Integer 'The current cover number
Public iPages          As Integer 'The total number of pages of the current album
Public iMaxPics        As Integer 'The maximum number of picture boxes per page
Public iMaxTxts        As Integer 'The maximum number of text boxes per page
Public iCvrWdTw        As Long    'The constant cover width (on screen) in twips
Public iCvrHtTw        As Long    'The constant cover height (on screen) in twips
Public iCvrWdMm        As Integer 'The constant cover width in mm
Public iCvrHtMm        As Integer 'The constant cover height in mm
Public iGlobalJPG      As Integer 'The global JPEG quality factor in %
Public iPicIdx         As Integer 'The picture index
Public iTxtIdx         As Integer 'The text index
Public iSort           As Integer
Public sAlbName        As String  'The current album name
Public sOrder          As String  'The current order number
Public sMyAlbums       As String  'The directory containing personal albums
Public arrPic()        As String  'Array of picturebox-indexes with the source filename (if any)
Public arrPicCvr()     As String  'Array of picturebox-indexes with the source filename (if any) of the cover
Public arrInfo()       As String  'Array containing image information (resolution in pixels & size in kB)
Public fThmb           As Single  'The factor from thumbnail to normal size
Public fResz           As Single  'The factor from constant to resized size
Public fZoom           As Single  'The zoom factor on the page
Public fZoomCvr        As Single  'The zoom factor on the cover
Public sHost           As String  'Host name / Host IP address
Public bSaved          As Boolean 'Are the last changes in the album saved or not?
Public bResizing       As Boolean
Public sStory          As String  'The name of the story
Public sPreview        As String  'The name of the story to be previewed
Public sPerson         As String  'The name of the person
Public sName           As String
Public sEmail          As String
Public sGender         As String
Public iWindowsVersion As Integer
Public iStackPtr       As Integer
Public bShowStartup    As Boolean
Public bPopupShown     As Boolean
Public bPopup2Shown    As Boolean

'News:
Public oDOMAlbum    As New MSXML.DOMDocument 'The DOM document which contains the XML of the album currently working on
Public oDOMCover    As New MSXML.DOMDocument 'The DOM document which contains the XML of the cover currently working on
Public oDOMStates() As New MSXML.DOMDocument 'The stack of DOM documents which contain the XML of the album before the last change
Public oDOMFaces    As New MSXML.DOMDocument 'The DOM document containing the faces
Public oDOMErrors   As New MSXML.DOMDocument 'The DOM document containing the errors
Public Res          As New clsResolution
Public MultiLineTT  As New clsToolTip

'modGlobal's language dependent strings:
Public sPage        As String
Public sCover       As String
Public sProgress    As String
Public sMyAlbumsDir As String
Public sChanged     As String
Public sStoryDir    As String
Public sLanguage    As String
Public sPartner     As String
Public sAppName     As String
Public sAppMail     As String
Public sPixels      As String

'*************************
'* Private declarations: *
'*************************

'Read settings from INI-file:
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

'Write settings to INI-file:
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

'Declarations for direct ping:
Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal lpszAgent As String, ByVal dwAccessType As Long, ByVal lpszProxyName As String, ByVal lpszProxyBypass As String, ByVal dwFlags As Long) As Long
Private Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInet As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Long

'Constants for direct ping:
Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const INTERNET_FLAG_KEEP_CONNECTION = &H400000
Private Const INTERNET_FLAG_NO_CACHE_WRITE = &H4000000

'Declaration for FTP check:
Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" (ByVal hInternetSession As Long, ByVal sServerName As String, ByVal nServerPort As Integer, ByVal sUsername As String, ByVal sPassword As String, ByVal lService As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long

'Declaration for Open in Browser:
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'Declaration & const for horizontal flip:
Private Const SRCCOPY = &HCC0020
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Private Type POINTAPI

  X As Long
  Y As Long

End Type

Private Const PI As Double = 3.14159265358979

'Constants used by the CombineRgn function:
Private Const RGN_AND As Integer = 1
Private Const RGN_OR As Integer = 2
Private Const RGN_XOR As Integer = 3
Private Const RGN_DIFF As Integer = 4
Private Const RGN_COPY As Integer = 5

Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetPixel& Lib "gdi32" (ByVal hDC&, ByVal X&, ByVal Y&)
Private Declare Function SetWindowRgn Lib "user32" (ByVal HWND As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function PlgBlt Lib "gdi32" (ByVal hdcDest As Long, lpPoint As POINTAPI, ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As Long, ByVal xMask As Long, ByVal yMask As Long) As Long

'Only usable in XP or later:
Private Declare Function PrintWindow Lib "user32" (ByVal HWND As Long, ByVal hdcBlt As Long, ByVal nFlags As Long) As Long

'Compare 2 XML elements (including their children and children's attributes) and return true only when they are exactly the same:
Public Function CompareElements(ByRef oEl1 As MSXML.IXMLDOMElement, ByRef oEl2 As MSXML.IXMLDOMElement) As Boolean

  On Error GoTo Error_Handler
  
  Dim oElem As MSXML.IXMLDOMElement
  Dim oAttr As MSXML.IXMLDOMAttribute
  Dim i     As Integer
  Dim j     As Integer
  
  If (oEl1 Is Nothing) Or (oEl2 Is Nothing) Then GoTo Exit_Function
  If oEl1.baseName <> oEl2.baseName Then GoTo Exit_Function
  If oEl1.childNodes.length <> oEl2.childNodes.length Then GoTo Exit_Function
  If oEl1.Attributes.length <> oEl2.Attributes.length Then GoTo Exit_Function
  
  For Each oAttr In oEl1.Attributes
  
    If oAttr.baseName <> oEl2.Attributes(i).baseName Then GoTo Exit_Function
    If oAttr.Text <> oEl2.Attributes(i).Text Then GoTo Exit_Function
    i = i + 1
    
  Next
  
  i = 0
  
  For Each oElem In oEl1.childNodes
  
    If oElem.baseName <> oEl2.childNodes(i).baseName Then GoTo Exit_Function
    If oElem.Attributes.length <> oEl2.childNodes(i).Attributes.length Then GoTo Exit_Function
    j = 0
    
    For Each oAttr In oElem.Attributes
    
      If oAttr.baseName <> oEl2.childNodes(i).Attributes(j).baseName Then GoTo Exit_Function
      If oAttr.Text <> oEl2.childNodes(i).Attributes(j).Text Then GoTo Exit_Function
      j = j + 1
      
    Next
    
    i = i + 1
    
  Next
  
  CompareElements = True
Exit_Function:
  Set oElem = Nothing
  Set oAttr = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CompareElements", Erl
  Resume Next
  
End Function

'Compare 2 XML elements by the first 4 attributes and return true only when they are exactly the same:
Public Function CompareAttributes(ByRef oEl1 As MSXML.IXMLDOMElement, ByRef oEl2 As MSXML.IXMLDOMElement) As Boolean

  On Error GoTo Error_Handler
  
  Dim oAttr As MSXML.IXMLDOMAttribute
  Dim i     As Integer
  
  If oEl1.baseName <> oEl2.baseName Then GoTo Exit_Function
  i = 0
  
  For Each oAttr In oEl1.Attributes
  
    If oAttr.baseName <> oEl2.Attributes(i).baseName Then GoTo Exit_Function
    If oAttr.Text <> oEl2.Attributes(i).Text Then GoTo Exit_Function
    If i = 3 Then Exit For
    i = i + 1
    
  Next
  
  CompareAttributes = True
Exit_Function:
  Set oAttr = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CompareAttributes", Erl
  Resume Next
  
End Function

Public Sub SaveThumb(ByVal iPg As Integer)

  On Error GoTo Error_Handler
  
  Dim lTemp1 As Long
  Dim lTemp2 As Long
  Dim lTemp  As Long
  
  If frmMyPersonalStory.TabStrip1.SelectedItem.Key = "tab2" Then
  
    If frmMyPersonalStory.frmPage(iPg).Left + frmMyPersonalStory.frmPage(iPg).Width > frmMyPersonalStory.picSlidePage.Width Then
    
      lTemp1 = frmMyPersonalStory.picSlidePage.Width
      frmMyPersonalStory.picSlidePage.Width = frmMyPersonalStory.picSlidePage.Width + frmMyPersonalStory.frmPage(iPg).Left + frmMyPersonalStory.frmPage(iPg).Width
      
    End If
    
    If frmMyPersonalStory.frmPage(iPg).Top + frmMyPersonalStory.frmPage(iPg).Height > frmMyPersonalStory.picSlidePage.Height Then
    
      lTemp2 = frmMyPersonalStory.picSlidePage.Height
      frmMyPersonalStory.picSlidePage.Height = frmMyPersonalStory.picSlidePage.Height + frmMyPersonalStory.frmPage(iPg).Top + frmMyPersonalStory.frmPage(iPg).Height
      
    End If
    
  End If
  
  If (frmMyPersonalStory.frmPage(iPg).Top + frmMyPersonalStory.frmPage(iPg).Height) * iTwY > frmMyPersonalStory.picPages.Height Then
  
    lTemp = frmMyPersonalStory.picSlidePage.Top
    frmMyPersonalStory.picSlidePage.Top = -(frmMyPersonalStory.frmPage(iPg).Top + frmMyPersonalStory.frmPage(iPg).Height + 4 - frmMyPersonalStory.picPages.Height \ iTwY)
    PrintWindow frmMyPersonalStory.frmPage(iPg).HWND, frmMyPersonalStory.frmPage(iPg).hDC, 0
    frmMyPersonalStory.picSlidePage.Top = lTemp
    
  ElseIf frmMyPersonalStory.frmPage(iPg).Top < -frmMyPersonalStory.picSlidePage.Top Then
  
    lTemp = frmMyPersonalStory.picSlidePage.Top
    frmMyPersonalStory.picSlidePage.Top = -frmMyPersonalStory.frmPage(iPg).Top
    PrintWindow frmMyPersonalStory.frmPage(iPg).HWND, frmMyPersonalStory.frmPage(iPg).hDC, 0
    frmMyPersonalStory.picSlidePage.Top = lTemp
    
  Else
  
    PrintWindow frmMyPersonalStory.frmPage(iPg).HWND, frmMyPersonalStory.frmPage(iPg).hDC, 0
    
  End If
  
  If lTemp1 <> 0 Then frmMyPersonalStory.picSlidePage.Width = lTemp1
  If lTemp2 <> 0 Then frmMyPersonalStory.picSlidePage.Height = lTemp2
  On Error Resume Next
  SavePicture frmMyPersonalStory.frmPage(iPg).Image, sMyAlbums & sAlbName & "\" & iPg & "_.bmp"
  On Error GoTo Error_Handler
  frmMyPersonalStory.UnloadPage iPg
  On Error Resume Next
  frmMyPersonalStory.frmPage(iPg).Picture = LoadPicture(sMyAlbums & sAlbName & "\" & iPg & "_.bmp")
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:SaveThumb", Erl
  Resume Next
  
End Sub

Public Sub DrawRotatedEllipse(ByRef oImg As Image, ByRef oPic As PictureBox, ByVal Angle As Single)

  On Error GoTo Error_Handler
  
  Const PI = 3.14159265
  
  Dim pt()      As POINTAPI
  Dim iPoints   As Integer
  Dim hRegion   As Long
  Dim sin_angle As Single
  Dim cos_angle As Single
  Dim theta     As Single
  Dim dtheta    As Single
  Dim X         As Single 'A point on the ellipse
  Dim Y         As Single
  Dim RX        As Single 'The point rotated
  Dim RY        As Single
  Dim wid       As Single
  Dim hgt       As Single
  Dim cx        As Single
  Dim cy        As Single
  
  oPic.ScaleMode = vbTwips
  wid = oImg.Width / 2
  hgt = oImg.Height / 2
  cx = oPic.ScaleWidth / 2
  cy = oPic.ScaleHeight / 2
  
  Angle = Angle * PI / 180
  sin_angle = Sin(Angle)
  cos_angle = Cos(Angle)
  
  theta = 0
  dtheta = 2 * PI / 50
  
  Do While theta < 2 * PI
  
    X = wid * Cos(theta)
    Y = hgt * Sin(theta)
    
    RX = cx + X * cos_angle + Y * sin_angle
    RY = cy - X * sin_angle + Y * cos_angle
    
    iPoints = iPoints + 1
    ReDim Preserve pt(iPoints - 1)
    pt(iPoints - 1).X = RX / iTwX
    pt(iPoints - 1).Y = RY / iTwY
    
    theta = theta + dtheta
    
  Loop
  
  hRegion = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  SetWindowRgn oPic.HWND, hRegion, True
  DeleteObject hRegion
  ReDim pt(0)
  
  oPic.ScaleMode = vbPixels
  oPic.ZOrder 0
  oPic.Visible = True
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:DrawRotatedEllipse", Erl
  Resume Next
  
End Sub

Public Sub DrawCornersRot(ByRef oImg As Image, ByRef oPic As PictureBox)

  On Error GoTo Error_Handler
  
  Dim pt()    As POINTAPI
  Dim hRegion As Long
  Dim iPoints As Integer
  Dim Angle   As Single
  
  Const PI = 3.14159265
  
  If oImg.Tag <> vbNullString Then
  
    Angle = CInt(oPic.Tag)
    Angle = Angle Mod 360
    If Angle < 0 Then Angle = Angle + 360 '0 <= Angle < 360
    
    Dim sPoints As String
    Dim Ix()    As Long
    Dim Iy()    As Long
    Dim lMaxIx  As Long
    Dim lMaxIy  As Long
    Dim O_TX    As Long
    Dim O_TY    As Long
    Dim i       As Integer
    
    iPoints = CInt(mid(oImg.Tag, 2, InStr(oImg.Tag, ";") - 2))
    sPoints = mid(oImg.Tag, InStr(oImg.Tag, ";") + 1)
    ReDim Ix(iPoints - 1)
    ReDim Iy(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      Ix(i) = CLng(Left(sPoints, InStr(sPoints, ",") - 1))
      Iy(i) = CLng(mid(sPoints, InStr(sPoints, ",") + 1, InStr(sPoints, " ") - InStr(sPoints, ",") - 1))
      sPoints = mid(sPoints, InStr(sPoints, " ") + 1)
      
    Next i
    
    lMaxIx = MaxArr(Ix)
    lMaxIy = MaxArr(Iy)
    
    Dim lWidthSrc  As Long
    Dim lHeightSrc As Long
    Dim TX         As Integer 'X-translation
    Dim TY         As Integer 'Y-translation
    
    lWidthSrc = oImg.Width
    lHeightSrc = oImg.Height
    
    If (Angle < 90) Or (Angle < 270 And Angle >= 180) Then
    
      If lWidthSrc > lHeightSrc * Sin((Angle Mod 90) * PI / 180) + lWidthSrc * Cos((Angle Mod 90) * PI / 180) Then
      
        TX = RoundUp((lWidthSrc - (lHeightSrc * Sin((Angle Mod 90) * PI / 180) + lWidthSrc * Cos((Angle Mod 90) * PI / 180))) / 2)
        
      End If
      
      If lHeightSrc > lHeightSrc * Cos((Angle Mod 90) * PI / 180) + lWidthSrc * Sin((Angle Mod 90) * PI / 180) Then
      
        TY = RoundUp((lHeightSrc - (lHeightSrc * Cos((Angle Mod 90) * PI / 180) + lWidthSrc * Sin((Angle Mod 90) * PI / 180))) / 2)
        
      End If
      
    Else
    
      If lWidthSrc > lWidthSrc * Sin((Angle Mod 90) * PI / 180) + lHeightSrc * Cos((Angle Mod 90) * PI / 180) Then
      
        TX = RoundUp((lWidthSrc - (lWidthSrc * Sin((Angle Mod 90) * PI / 180) + lHeightSrc * Cos((Angle Mod 90) * PI / 180))) / 2)
        
      End If
      
      If lHeightSrc > lWidthSrc * Cos((Angle Mod 90) * PI / 180) + lHeightSrc * Sin((Angle Mod 90) * PI / 180) Then
      
        TY = RoundUp((lHeightSrc - (lWidthSrc * Cos((Angle Mod 90) * PI / 180) + lHeightSrc * Sin((Angle Mod 90) * PI / 180))) / 2)
        
      End If
      
    End If
    
    ReDim pt(4)
    
    pt(0).X = 0 + TX / Screen.TwipsPerPixelX
    pt(1).Y = 0 + TY / Screen.TwipsPerPixelY
    
    If (Angle >= 0 And Angle < 90) Or (Angle >= 180 And Angle < 270) Then
    
      pt(0).Y = (lWidthSrc * Sin((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      pt(1).X = (lWidthSrc * Cos((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(2).X = (lHeightSrc * Sin((Angle Mod 90) * PI / 180) + lWidthSrc * Cos((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(2).Y = (lHeightSrc * Cos((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      pt(3).X = (lHeightSrc * Sin((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(3).Y = (lHeightSrc * Cos((Angle Mod 90) * PI / 180) + lWidthSrc * Sin((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      
    ElseIf (Angle >= 90 And Angle < 180) Or (Angle >= 270 And Angle < 360) Then
    
      pt(0).Y = (lHeightSrc * Sin((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      pt(1).X = (lHeightSrc * Cos((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(2).X = (lWidthSrc * Sin((Angle Mod 90) * PI / 180) + lHeightSrc * Cos((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(2).Y = (lWidthSrc * Cos((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      pt(3).X = (lWidthSrc * Sin((Angle Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
      pt(3).Y = (lWidthSrc * Cos((Angle Mod 90) * PI / 180) + lHeightSrc * Sin((Angle Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
      
    End If
    
    pt(4).X = pt(0).X
    pt(4).Y = pt(0).Y
    
    If (Angle >= 0 And Angle < 90) Then
    
      O_TX = pt(0).X
      O_TY = pt(0).Y
      
    ElseIf (Angle >= 270 And Angle < 360) Then
    
      O_TX = pt(1).X
      O_TY = pt(1).Y
      
    ElseIf (Angle >= 180 And Angle < 270) Then
    
      O_TX = pt(2).X
      O_TY = pt(2).Y
      
    ElseIf (Angle >= 90 And Angle < 180) Then
    
      O_TX = pt(3).X
      O_TY = pt(3).Y
      
    End If
    
    ReDim pt(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      pt(i).X = Ix(i) / lMaxIx * oImg.Width / iTwX * Cos(Angle * PI / 180) + Iy(i) / lMaxIy * oImg.Height / iTwY * Sin(Angle * PI / 180) + O_TX
      pt(i).Y = Iy(i) / lMaxIy * oImg.Height / iTwY * Cos(Angle * PI / 180) - Ix(i) / lMaxIx * oImg.Width / iTwX * Sin(Angle * PI / 180) + O_TY
      
    Next i
    
    hRegion = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
    ReDim Ix(0)
    ReDim Iy(0)
    
  Else
  
    Dim sin_angle As Single
    Dim cos_angle As Single
    Dim theta     As Single
    Dim dtheta    As Single
    Dim X         As Single 'A point on the ellipse
    Dim Y         As Single
    Dim RX        As Single 'The point rotated
    Dim RY        As Single
    Dim wid       As Single
    Dim hgt       As Single
    Dim cx        As Single
    Dim cy        As Single
    
    Angle = CInt(oPic.Tag) * PI / 180
    
    oPic.ScaleMode = vbTwips
    wid = oImg.Width / 2
    hgt = oImg.Height / 2
    cx = oPic.Width / 2
    cy = oPic.Height / 2
    
    sin_angle = Sin(Angle)
    cos_angle = Cos(Angle)
    
    theta = 0
    dtheta = 2 * PI / 50
    
    Do While theta < 2 * PI
    
      X = wid * Cos(theta)
      Y = hgt * Sin(theta)
      
      RX = cx + X * cos_angle + Y * sin_angle
      RY = cy - X * sin_angle + Y * cos_angle
      
      iPoints = iPoints + 1
      ReDim Preserve pt(iPoints - 1)
      pt(iPoints - 1).X = RX / iTwX
      pt(iPoints - 1).Y = RY / iTwY
      
      theta = theta + dtheta
      
    Loop
    
    hRegion = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
    oPic.ScaleMode = vbPixels
    
  End If
  
  Dim hRegion1 As Long
  Dim hRegion2 As Long
  Dim hRegion3 As Long
  Dim hRegion4 As Long
  
  ReDim pt(2)
  pt(0).X = 0
  pt(0).Y = 0
  pt(1).X = 10
  pt(1).Y = 0
  pt(2).X = 0
  pt(2).Y = 10
  hRegion1 = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  ReDim pt(2)
  pt(0).X = oPic.Width / iTwX
  pt(0).Y = 0
  pt(1).X = oPic.Width / iTwX
  pt(1).Y = 10
  pt(2).X = oPic.Width / iTwX - 10
  pt(2).Y = 0
  hRegion2 = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  ReDim pt(2)
  pt(0).X = oPic.Width / iTwX
  pt(0).Y = oPic.Height / iTwY
  pt(1).X = oPic.Width / iTwX - 10
  pt(1).Y = oPic.Height / iTwY
  pt(2).X = oPic.Width / iTwX
  pt(2).Y = oPic.Height / iTwY - 10
  hRegion3 = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  ReDim pt(2)
  pt(0).X = 0
  pt(0).Y = oPic.Height / iTwY
  pt(1).X = 0
  pt(1).Y = oPic.Height / iTwY - 10
  pt(2).X = 10
  pt(2).Y = oPic.Height / iTwY
  hRegion4 = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  CombineRgn hRegion, hRegion, hRegion1, RGN_OR
  CombineRgn hRegion, hRegion, hRegion2, RGN_OR
  CombineRgn hRegion, hRegion, hRegion3, RGN_OR
  CombineRgn hRegion, hRegion, hRegion4, RGN_OR
  SetWindowRgn frmMyPersonalStory.picDyn.HWND, hRegion, True
  DeleteObject hRegion
  DeleteObject hRegion1
  DeleteObject hRegion2
  DeleteObject hRegion3
  DeleteObject hRegion4
  ReDim pt(0)
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:DrawCornersRot", Erl
  Resume Next
  
End Sub
  
'*************
'* INI-file: *
'*************

'Get string from .ini-file:
Public Function GetFromINI(ByVal sSection As String, ByVal sEntry As String) As String

  On Error GoTo Error_Handler
  
  Dim sRetBuf As String
  
  If sSection = vbNullString Or sEntry = vbNullString Then Exit Function
  sRetBuf = String(511, 0) '511 null characters
  GetFromINI = Left(sRetBuf, GetPrivateProfileString(sSection, sEntry, vbNullString, sRetBuf, Len(sRetBuf), App.Path & IIf(Right(App.Path, 1) = "\", vbNullString, "\") & "Text.ini"))
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:GetFromINI", Erl
  Resume Next
  
End Function

'Replace RETURN/RETURN_BLANK's in str by vbCrLf's:
Public Function ReplaceReturn(ByVal str As String) As String

  On Error GoTo Error_Handler
  ReplaceReturn = Replace(Replace(str, "<RETURN_BLANK/>", vbCrLf), "<RETURN/>", vbCrLf)
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:ReplaceReturn", Erl
  Resume Next
  
End Function

'********
'* RGB: *
'********

'Return the VB color (long) for a given RGB value (hexadecimal):
Public Function RGB2VB(ByVal strRGB As String) As Long

  On Error GoTo Error_Handler
  If strRGB = vbNullString Then Exit Function
  RGB2VB = RGB(CLng("&H" & Left(strRGB, 2)), CLng("&H" & mid(strRGB, 3, 2)), CLng("&H" & Right(strRGB, 2)))
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:RGB2VB", Erl
  Resume Next
  
End Function

'Return the RGB value (string) for a given VB color (long):
Public Function VB2RGB(ByVal lngVB As Long) As String

  On Error GoTo Error_Handler
  VB2RGB = IIf(Len(Hex(ExtractR(lngVB))) = 1, "0" & Hex(ExtractR(lngVB)), Hex(ExtractR(lngVB))) _
         & IIf(Len(Hex(ExtractG(lngVB))) = 1, "0" & Hex(ExtractG(lngVB)), Hex(ExtractG(lngVB))) _
         & IIf(Len(Hex(ExtractB(lngVB))) = 1, "0" & Hex(ExtractB(lngVB)), Hex(ExtractB(lngVB)))
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:VB2RGB", Erl
  Resume Next
  
End Function

Public Function ExtractR(ByVal CurrentColor As Long) As Byte

  On Error GoTo Error_Handler
  ExtractR = CurrentColor And 255
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:ExtractR", Erl
  Resume Next
  
End Function

Public Function ExtractG(ByVal CurrentColor As Long) As Byte

  On Error GoTo Error_Handler
  ExtractG = (CurrentColor \ 256) And 255
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:ExtractG", Erl
  Resume Next
  
End Function

Public Function ExtractB(ByVal CurrentColor As Long) As Byte

  On Error GoTo Error_Handler
  ExtractB = (CurrentColor \ 65536) And 255
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:ExtractB", Erl
  Resume Next
  
End Function

'******************
'* Close winsock: *
'******************

Public Sub CloseWinsock(ByRef oWinsock As Winsock)

  On Error GoTo Error_Handler
  
  If Not oWinsock.State = sckClosed Then
      
    oWinsock.Close
    
    Do Until oWinsock.State = sckClosed
        
      DoEvents
    
    Loop
  
  End If

  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:CloseWinsock", Erl
  Resume Next
  
End Sub

'****************
'* Direct ping: *
'****************

Public Function CheckInternet() As Boolean

  On Error GoTo Error_Handler
  
  Dim hInet As Long
  Dim hUrl  As Long
  Dim Flags As Long
  
  hInet = InternetOpen(App.Title, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0&)
  
  If hInet Then
  
    Flags = INTERNET_FLAG_KEEP_CONNECTION Or INTERNET_FLAG_NO_CACHE_WRITE Or INTERNET_FLAG_RELOAD
    hUrl = InternetOpenUrl(hInet, "http://www.mypersonalstory.be", vbNullString, 0, Flags, 0)
    
    If hUrl = 0 Then
    
      CheckInternet = True
      
    End If
     
  End If
  
  InternetCloseHandle hInet
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CheckInternet", Erl
  Resume Next
  
End Function

Public Function CheckFTP() As Boolean

  On Error GoTo Error_Handler
  
  Dim hInet As Long
  Dim hUrl  As Long
  
  hInet = InternetOpen(App.Title, 1, vbNullString, vbNullString, 0)
  
  If hInet Then
  
    hUrl = InternetConnect(hInet, sHost, 0, USER_NAME, PASS_WORD, 1, 0, 0)
    
    If hUrl = 0 Then
    
      CheckFTP = True
      
    End If
     
  End If
  
  InternetCloseHandle hInet
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CheckFTP", Erl
  Resume Next
  
End Function

'********************
'* Open in Browser: *
'********************

Public Sub OpenBrowser(ByVal URL As String)

  On Error GoTo Error_Handler
  
  Dim APIReturnCode As Long
  
  If URL = vbNullString Then Exit Sub
  
  APIReturnCode = ShellExecute(0, "open", URL, vbNullString, App.Path, 0)
  
  If APIReturnCode < 31 Then
  
    MsgBox "Problem running your web browser. You should check that your browser is correctly installed. (Error " & Format$(APIReturnCode) & ")", 48, "Browser Unavailable"
    
  ElseIf APIReturnCode = 32 Then
  
    MsgBox App.Title & " could not find a file association for " & URL & " on your system. You should check that your browser is correctly installed and associated with this type of file.", 48, "Browser Unavailable"
    
  End If

  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:OpenBrowser", Erl
  Resume Next
  
End Sub

'****************
'* HTTPRequest: *
'****************

Public Function HTTPRequest(ByRef oInet As Inet, ByVal sURL As String) As String

  On Error Resume Next
  
  With oInet
  
    .Protocol = icHTTP
    
    While .StillExecuting
      
      DoEvents
    
    Wend
    
    HTTPRequest = .OpenURL(sURL)
    
    While .StillExecuting
      
      DoEvents
    
    Wend
    
  End With
  
End Function

'*********************
'* CheckEmptyFrames: *
'*********************

Public Function CheckEmptyFrames() As Boolean

  On Error GoTo Error_Handler
  
  Dim oElem As MSXML.IXMLDOMElement
  Dim iCnt  As Integer
  Dim iRes  As Integer
  
  CheckEmptyFrames = True
  
  For Each oElem In oDOMAlbum.documentElement.childNodes
  
    If CheckEmptyFrame(oElem) Then iCnt = iCnt + 1
    
  Next
  
  If iCnt > 0 Then
  
    MsgBox GetFromINI("modGlobal", "CheckEmptyFrames1a") & " " & iCnt & " " & GetFromINI("modGlobal", "CheckEmptyFrames1b") & vbCrLf & GetFromINI("modGlobal", "CheckEmptyFrames2"), vbOKOnly, sAppName
    CheckEmptyFrames = False
    Set oElem = Nothing
    Exit Function
    
  End If
  
  iCnt = 0
  
  For Each oElem In oDOMCover.documentElement.childNodes
  
    If CheckEmptyFrame(oElem) Then iCnt = iCnt + 1
    
  Next
  
  If iCnt > 0 Then
  
    MsgBox GetFromINI("modGlobal", "CheckEmptyCover"), vbOKOnly, sAppName
    CheckEmptyFrames = False
    
  End If
  
  Set oElem = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CheckEmptyFrames", Erl
  Resume Next
  
End Function
    
'********************
'* CheckEmptyFrame: *
'********************

Private Function CheckEmptyFrame(ByRef oEl As MSXML.IXMLDOMElement) As Boolean

  On Error GoTo Error_Handler
  If oEl Is Nothing Then Exit Function
  
  Dim oElem As MSXML.IXMLDOMElement
  
  For Each oElem In oEl.childNodes
  
    If oElem.baseName = "PICTURE" Then
    
      If oElem.getAttribute("FILE") = vbNullString Then
      
        CheckEmptyFrame = True
        Exit For
        
      End If
      
    End If
    
  Next
  
  Set oElem = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CheckEmptyFrame", Erl
  Resume Next
  
End Function

'********************
'* SetTranslations: *
'********************

Public Sub SetTranslations(ByRef oElement As MSXML.IXMLDOMElement)

  On Error GoTo Error_Handler
  
  Dim iRotation As Integer
  Dim lWidth    As Long
  Dim lHeight   As Long
  Dim TX        As Integer 'X-translation
  Dim TY        As Integer 'Y-translation
  
  iRotation = oElement.getAttribute("ROTATION") Mod 360
  lWidth = oElement.getAttribute("WIDTH2")
  lHeight = oElement.getAttribute("HEIGHT2")
  
  If (iRotation = 90) And (lHeight > lWidth) Then
  
    TY = lHeight - (lHeight - lWidth) / 2
    
  ElseIf (iRotation = 270) And (lHeight > lWidth) Then
  
    TX = lHeight
    TY = (lHeight - lWidth) / 2
    
  Else
  
    If (iRotation < 90) Or (iRotation < 270 And iRotation >= 180) Then
    
      If lWidth > lHeight * Sin((iRotation Mod 90) * PI / 180) + lWidth * Cos((iRotation Mod 90) * PI / 180) Then
      
        TX = (lWidth - (lHeight * Sin((iRotation Mod 90) * PI / 180) + lWidth * Cos((iRotation Mod 90) * PI / 180))) / 2
        
      End If
      
      If lHeight > lHeight * Cos((iRotation Mod 90) * PI / 180) + lWidth * Sin((iRotation Mod 90) * PI / 180) Then
      
        TY = (lHeight - (lHeight * Cos((iRotation Mod 90) * PI / 180) + lWidth * Sin((iRotation Mod 90) * PI / 180))) / 2
        
      End If
      
    Else
    
      If lWidth > lWidth * Sin((iRotation Mod 90) * PI / 180) + lHeight * Cos((iRotation Mod 90) * PI / 180) Then
      
        TX = (lWidth - (lWidth * Sin((iRotation Mod 90) * PI / 180) + lHeight * Cos((iRotation Mod 90) * PI / 180))) / 2
        
      End If
      
      If lHeight > lWidth * Cos((iRotation Mod 90) * PI / 180) + lHeight * Sin((iRotation Mod 90) * PI / 180) Then
      
        TY = (lHeight - (lWidth * Cos((iRotation Mod 90) * PI / 180) + lHeight * Sin((iRotation Mod 90) * PI / 180))) / 2
        
      End If
      
    End If
    
    If iRotation >= 0 And iRotation < 90 Then
    
      TY = TY + Round(lWidth * Sin(iRotation * PI / 180))
      
    ElseIf iRotation >= 90 And iRotation < 180 Then
    
      TX = TX + Round(lWidth * Cos((180 - iRotation) * PI / 180))
      TY = TY + oElement.getAttribute("HEIGHT")
      
    ElseIf iRotation >= 180 And iRotation < 270 Then
    
      TX = TX + oElement.getAttribute("WIDTH")
      TY = TY + Round(lHeight * Cos((iRotation - 180) * PI / 180))
      
    ElseIf iRotation >= 270 And iRotation < 360 Then
    
      TX = TX + Round(lHeight * Cos((iRotation - 270) * PI / 180))
      
    End If
    
  End If
  
  oElement.setAttribute "TRANSLATION_X", TX
  oElement.setAttribute "TRANSLATION_Y", TY
  
  If oElement.getAttribute("POLYGON") = vbNullString Or oElement.getAttribute("ROTATION") = "0" Then
  
  ElseIf CInt(oElement.getAttribute("POLYGON")) > 0 Then 'In pixels
  
    oElement.setAttribute "TRANSLATION_X2", Round(TX / CLng(oElement.getAttribute("WIDTH")) * CLng(oElement.getAttribute("XMAX2")))
    oElement.setAttribute "TRANSLATION_Y2", Round(TY / CLng(oElement.getAttribute("HEIGHT")) * CLng(oElement.getAttribute("YMAX2")))
    
  End If
  
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:SetTranslations", Erl
  Resume Next
  
End Sub

'************
'* DOMLoad: *
'************

Public Function DOMLoad(ByRef oDOM As MSXML.DOMDocument, ByVal sFile As String) As Boolean
'Load the XML file sFile in the DOMDocument oDOM

  On Error GoTo Error_Handler
  
  oDOM.async = False            'The XML message must be fully loaded, before the program continues
  oDOM.validateOnParse = False  'No DTD => validation unnecessary
  oDOM.resolveExternals = False 'Disable external references
  
  If oDOM.Load(sFile) = False Then 'Errors generated during parse process => error message:
  
    MsgBox GetFromINI("modGlobal", "oDOM.parseError") & vbCrLf & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.Line") & " " & oDOM.parseError.Line & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.linepos") & " " & oDOM.parseError.linepos & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.srcText") & " " & oDOM.parseError.srcText & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.errorCode") & " " & oDOM.parseError.errorCode & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.reason") & " " & oDOM.parseError.reason, vbCritical, sAppName
    DOMLoad = False
    
  Else
  
    DOMLoad = True
  
  End If
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:DOMLoad", Erl
  Resume Next
  
End Function

'***************
'* DOMLoadXML: *
'***************

Public Function DOMLoadXML(ByRef oDOM As MSXML.DOMDocument, ByVal sString As String) As Boolean
'Load the XML sString in the DOMDocument oDOM

  On Error GoTo Error_Handler
  
  oDOM.async = False            'The XML message must be fully loaded, before the program continues
  oDOM.validateOnParse = False  'No DTD => validation unnecessary
  oDOM.resolveExternals = False 'Disable external references
  
  If oDOM.loadXML(sString) = False Then 'Errors generated during parse process => error message:
  
    MsgBox GetFromINI("modGlobal", "oDOM.parseError") & vbCrLf & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.Line") & " " & oDOM.parseError.Line & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.linepos") & " " & oDOM.parseError.linepos & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.srcText") & " " & oDOM.parseError.srcText & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.errorCode") & " " & oDOM.parseError.errorCode & vbCrLf _
         & GetFromINI("modGlobal", "oDOM.parseError.reason") & " " & oDOM.parseError.reason, vbCritical, sAppName
    DOMLoadXML = False
    
  Else
  
    DOMLoadXML = True
  
  End If
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:DOMLoadXML", Erl
  Resume Next
  
End Function

'************
'* DOMSave: *
'************

Public Function DOMSave(ByRef oDOM As MSXML.DOMDocument, ByVal sDestination As String) As Boolean
'Save the DOM object oDOM in the XML file sDestination

  On Error GoTo Error_DOMSave
  oDOM.save sDestination
  DOMSave = True
  Exit Function
  
Error_DOMSave:
  MsgBox "Error saving DOM to '" & sDestination & "'.", vbCritical, sAppName
  DOMSave = False

End Function

'*************
'* FigInDOM: *
'*************

Public Function FigInDOM(sFigure As String) As Boolean
'Check if the figure is referenced by the DOM

  On Error GoTo Error_Handler
  
  If LCase(oDOMAlbum.documentElement.getAttribute("BACKGROUND")) = sFigure Then
  
    FigInDOM = True
    Exit Function
    
  End If
  
  Dim oElem  As MSXML.IXMLDOMElement
  Dim oElem2 As MSXML.IXMLDOMElement
  
  For Each oElem In oDOMAlbum.documentElement.childNodes
  
    If oElem.baseName = "PAGE" Then
    
      If LCase(oElem.getAttribute("BACKGROUND")) = sFigure Then
      
        FigInDOM = True
        Set oElem = Nothing
        Exit Function
        
      End If
      
    End If
    
  Next
  
  For Each oElem In oDOMAlbum.documentElement.childNodes
  
    If oElem.baseName = "PAGE" Then
    
      For Each oElem2 In oElem.childNodes
      
        If oElem2.baseName = "PICTURE" Then
        
          If LCase(oElem2.getAttribute("FILE")) = sFigure Then
          
            FigInDOM = True
            Exit For
            
          End If
          
        End If
        
      Next
      
    End If
    
  Next
  
  For Each oElem In oDOMCover.documentElement.childNodes
  
    If oElem.baseName = "PAGE" Then
    
      For Each oElem2 In oElem.childNodes
      
        If oElem2.baseName = "PICTURE" Then
        
          If LCase(oElem2.getAttribute("FILE")) = sFigure Then
          
            FigInDOM = True
            Exit For
            
          End If
          
        End If
        
      Next
      
    End If
    
  Next
  
  Set oElem2 = Nothing
  Set oElem = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:FigInDOM", Erl
  Resume Next
  
End Function

'***********
'* GetXML: *
'***********

Public Function GetXML(ByVal iIndex As Integer, ByVal sElement As String, ByVal sAttribute As String) As String
'Return XML attribute sAttribute value of element sElement at index iIndex

  On Error GoTo Error_Handler
  
  Dim oElem As MSXML.IXMLDOMElement
  Dim iMax  As Integer
  Dim iCnt  As Integer
  
  iMax = iMaxPics
  
  If frmMyPersonalStory.TabStrip1.SelectedItem.Key = "tab2" Then
  
    For Each oElem In oDOMAlbum.documentElement.childNodes((iIndex - 1) \ iMax).childNodes
    
      If oElem.baseName = sElement Then
      
        iCnt = iCnt + 1
        
        If iCnt = ((iIndex - 1) Mod iMax) + 1 Then
        
          GetXML = oElem.getAttribute(sAttribute)
          Exit For
          
        End If
        
      End If
      
    Next
    
  Else
  
    For Each oElem In oDOMCover.documentElement.childNodes((iIndex - 1) \ iMax).childNodes
    
      If oElem.baseName = sElement Then
      
        iCnt = iCnt + 1
        
        If iCnt = ((iIndex - 1) Mod iMax) + 1 Then
        
          GetXML = oElem.getAttribute(sAttribute)
          Exit For
          
        End If
        
      End If
      
    Next
    
  End If
  
  Set oElem = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "frmMyPersonalStory:GetXML", Erl
  Resume Next
  
End Function

'***************
'* ColumnSort: *
'***************

Public Sub ColumnSort(ByRef myListView As ListView, ByVal myColumnHeader As MSComctlLib.ColumnHeader)
  
  On Error GoTo Error_Handler
  
  With myListView
    
    Static iLast As Integer, iCur As Integer
    
    .Sorted = True
    iCur = myColumnHeader.Index - 1
    
    If iCur = iLast Then
      
      .SortOrder = IIf(.SortOrder = 1, 0, 1)
      
    End If
    
    .SortKey = iCur
    iLast = iCur
  
  End With

  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:ColumnSort", Erl
  Resume Next
  
End Sub

'************
'* Minimum: *
'************

Public Function Min(ByVal i1 As Integer, ByVal i2 As Integer) As Integer

  On Error GoTo Error_Handler
  
  If i1 <= i2 Then
  
    Min = i1
    
  Else
  
    Min = i2
    
  End If

  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:Min", Erl
  Resume Next
  
End Function

Public Function MinArr(ByRef Arr() As Long) As Long

  On Error GoTo Error_Handler
  
  Dim iCtr As Integer
  Dim iOld As Integer
  
  iOld = 0
  MinArr = Arr(iOld)
  
  For iCtr = 1 To UBound(Arr)
  
    If Arr(iCtr) < Arr(iOld) Then
    
      iOld = iCtr
      MinArr = Arr(iOld)
      
    End If
    
  Next iCtr
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:MinArr", Erl
  Resume Next
  
End Function

'************
'* Maximum: *
'************

Public Function Max(ByVal i1 As Integer, ByVal i2 As Integer) As Integer

  On Error GoTo Error_Handler
  
  If i1 >= i2 Then
  
    Max = i1
    
  Else
  
    Max = i2
    
  End If

  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:Max", Erl
  Resume Next
  
End Function

Public Function MaxArr(ByRef Arr() As Long) As Long

  On Error GoTo Error_Handler
  
  Dim iCtr As Integer
  Dim iOld As Integer
  
  iOld = 0
  MaxArr = Arr(iOld)
  
  For iCtr = 1 To UBound(Arr)
  
    If Arr(iCtr) > Arr(iOld) Then
    
      iOld = iCtr
      MaxArr = Arr(iOld)
      
    End If
    
  Next iCtr
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:MaxArr", Erl
  Resume Next
  
End Function

'*************
'* Bool2Int: *
'*************

Public Function Bool2Int(ByVal B As Boolean) As Integer

  On Error GoTo Error_Handler
  
  If B = True Then
  
    Bool2Int = 1
    
  Else
  
    Bool2Int = 0
    
  End If

  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:Bool2Int", Erl
  Resume Next
  
End Function

'************
'* InArray: *
'************

Public Function InArray(ByRef oArr() As String, ByVal sString As String) As Boolean
'Returns True if oArr contains sString, False otherwise

  On Error GoTo Error_Handler
  
  Dim i As Integer
  
  For i = 1 To UBound(oArr)
  
    If oArr(i) = sString Then
    
      InArray = True
      Exit For
    
    End If
  
  Next
  
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:InArray", Erl
  Resume Next
  
End Function

'***********************
'* IndexInArrayFrmPag: *
'***********************

Public Function IndexInArrayFrmPag(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.frmPage contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.frmPage
  
    If ctl.Index = iIndex Then
    
      IndexInArrayFrmPag = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayFrmPag", Erl
  Resume Next
  
End Function

'***********************
'* IndexInArrayFrmCvr: *
'***********************

Public Function IndexInArrayFrmCvr(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.frmCover contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.frmCover
  
    If ctl.Index = iIndex Then
    
      IndexInArrayFrmCvr = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayFrmCvr", Erl
  Resume Next
  
End Function

'********************
'* IndexInArrayPic: *
'********************

Public Function IndexInArrayPic(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.picPage contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.picPage
  
    If ctl.Index = iIndex Then
    
      IndexInArrayPic = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayPic", Erl
  Resume Next
  
End Function

'***********************
'* IndexInArrayPicCvr: *
'***********************

Public Function IndexInArrayPicCvr(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.picCover contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.picCover
  
    If ctl.Index = iIndex Then
    
      IndexInArrayPicCvr = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayPicCvr", Erl
  Resume Next
  
End Function

'***********************
'* IndexInArrayPicRot: *
'***********************

Public Function IndexInArrayPicRot(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.picPageRot contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.picPageRot
  
    If ctl.Index = iIndex Then
    
      IndexInArrayPicRot = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayPicRot", Erl
  Resume Next
  
End Function

'**************************
'* IndexInArrayPicRotCvr: *
'**************************

Public Function IndexInArrayPicRotCvr(ByVal iIndex As Integer) As Boolean
'Returns True if the the control array frmMyPersonalStory.picCoverRot contains a control at index iIndex, False otherwise

  On Error GoTo Error_Handler
  
  Dim ctl As Control
  
  For Each ctl In frmMyPersonalStory.picCoverRot
  
    If ctl.Index = iIndex Then
    
      IndexInArrayPicRotCvr = True
      Exit For
      
    End If
  
  Next
  
  Set ctl = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:IndexInArrayPicRotCvr", Erl
  Resume Next
  
End Function

'***************
'* MoveObject: *
'***************

Public Sub MoveObject(ByRef obj As Object, ByVal L As Long, ByVal T As Long, Optional ByVal W As Long, Optional ByVal H As Long)

  On Error GoTo Error_MoveObject1
  
  Dim B As Boolean
  
  B = obj.Visible
  On Error GoTo Error_Handler
  If B = True Then obj.Visible = False
  
  If W = 0 And H = 0 Then
  
    obj.Move L, T
    
  Else
  
    On Error GoTo Error_MoveObject2
    obj.Move L, T, W, H
    On Error GoTo Error_Handler
    
  End If
  
  If B = True Then obj.Visible = True
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:MoveObject(" & obj.Name & ")", Erl
  Resume Next
  
Error_MoveObject1:
  HandleError Err, "modGlobal:MoveObject1(" & obj.Name & ")", Erl
  Resume Next
  
Error_MoveObject2:
  HandleError Err, "modGlobal:MoveObject2(" & obj.Name & ")", Erl
  Resume Next
  
End Sub

'*****************
'* UnloadObject: *
'*****************

Public Sub UnloadObject(ByRef obj As Object)

  On Error Resume Next
  Unload obj
  
End Sub

'*******************
'* FlipHorizontal: *
'*******************

Public Sub FlipHor(ByRef pic1 As PictureBox, ByRef pic2 As PictureBox)

  On Error GoTo Error_Handler
  pic2.ScaleMode = pic1.ScaleMode
  pic2.Width = pic1.Width
  pic2.Height = pic1.Height
  On Error Resume Next
  StretchBlt pic2.hDC, pic1.ScaleWidth, 0, -pic1.ScaleWidth, pic1.ScaleHeight, pic1.hDC, 0, 0, pic1.ScaleWidth, pic1.ScaleHeight, SRCCOPY
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:FlipHor", Erl
  Resume Next
  
End Sub

'**************
'* ResizePic: *
'**************

Public Sub ResizePic(ByRef pic1 As PictureBox, ByRef pic2 As PictureBox, ByVal Width As Long, ByVal Height As Long)

  On Error GoTo Error_Handler
  pic2.AutoRedraw = True
  pic2.AutoSize = False
  pic2.Width = Width
  pic2.Height = Height
  pic2.PaintPicture pic1.Picture, pic2.ScaleLeft, pic2.ScaleTop, pic2.Width, pic2.Height
  pic2.Picture = pic2.Image
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:ResizePic", Erl
  Resume Next
  
End Sub

'**************
'* GetThumbs: *
'**************

Public Sub GetThumbs(ByRef oThumb As IkThumb, ByVal sThumbPath As String)

  On Error GoTo Error_Handler
  
  Dim fso As New FileSystemObject
  
  If fso.FolderExists(sThumbPath) = False Then
  
    Set fso = Nothing
    Exit Sub
    
  End If
  
  'Update thumbnail file:
  If oThumb.ThumbnailFile <> vbNullString Then
  
    On Error Resume Next
    oThumb.UpdateThumbnailFile
    On Error GoTo Error_Handler
    
  End If
  
  'The directory containing the images to be displayed as thumbnails:
  oThumb.FilePath = sThumbPath
  
  'Set the thumbnail file:
  oThumb.ThumbnailFile = sThumbPath & IIf(Right(sThumbPath, 1) = "\", vbNullString, "\") & "thumbnail.dat"
  
  Dim fld     As Folder
  Dim fls     As Files
  Dim fl      As File
  Dim iFilCnt As Integer
  
  If sThumbPath <> vbNullString Then
  
    Set fld = fso.GetFolder(sThumbPath)
    Set fls = fld.Files
    
  End If
  
  For Each fl In fls
  
    If InStr(oThumb.FileExt, UCase(Right(fl.Name, 3))) Then
    
      iFilCnt = iFilCnt + 1
      
    End If
    
  Next
  
  Set fl = Nothing
  Set fls = Nothing
  Set fld = Nothing
  Set fso = Nothing
  On Error Resume Next
  
  If iFilCnt > 0 Then
  
    frmProgress2.PB1.Max = iFilCnt
    frmProgress2.Show
    
  End If
  
  oThumb.GetFiles
  oThumb.Display
  frmProgress2.Hide
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:GetThumbs", Erl
  Resume Next
  
End Sub

'***************
'* FontExists: *
'***************

Public Function FontExists(sFontName As String) As Boolean
  
  On Error GoTo Error_Handler
  
  Dim oFont As New StdFont
  
  oFont.Name = sFontName
  FontExists = StrComp(sFontName, oFont.Name, vbTextCompare) = 0
  Set oFont = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:FontExists", Erl
  Resume Next
  
End Function

'**********************
'* CreateAlbumFolder: *
'**********************

Public Function CreateAlbumFolder(ByRef sAlbumName As String) As Boolean

  On Error GoTo Error_Handler
  
  If InStr(sAlbumName, "\") Or InStr(sAlbumName, "/") Or InStr(sAlbumName, ":") Or InStr(sAlbumName, "*") Or InStr(sAlbumName, "?") Or InStr(sAlbumName, Chr(34)) Or InStr(sAlbumName, "<") Or InStr(sAlbumName, ">") Or InStr(sAlbumName, "|") Then
  
    MsgBox GetFromINI("frmMyPersonalStory", "SaveAs1") & vbCrLf & "\ / : * ? " & Chr(34) & " < > |", vbCritical, sAppName
    Exit Function
    
  ElseIf InStr(sAlbumName, "'") Then
  
    MsgBox GetFromINI("modGlobal", "CheckSign1") & " ' " & GetFromINI("modGlobal", "CheckSign2"), vbExclamation, sAppName
    Exit Function
    
  ElseIf InStr(sAlbumName, "%") Then
  
    MsgBox GetFromINI("modGlobal", "CheckSign1") & " % " & GetFromINI("modGlobal", "CheckSign2"), vbExclamation, sAppName
    Exit Function
    
  ElseIf InStr(sAlbumName, "(") Then
  
    MsgBox GetFromINI("modGlobal", "CheckSign1") & " ( " & GetFromINI("modGlobal", "CheckSign2"), vbExclamation, sAppName
    Exit Function
    
  ElseIf InStr(sAlbumName, ")") Then
  
    MsgBox GetFromINI("modGlobal", "CheckSign1") & " ) " & GetFromINI("modGlobal", "CheckSign2"), vbExclamation, sAppName
    Exit Function
    
  ElseIf Right(sAlbumName, 1) = "." Then
  
    MsgBox GetFromINI("modGlobal", "CheckSign1") & " . " & GetFromINI("modGlobal", "CheckSign2"), vbExclamation, sAppName
    Exit Function
    
  End If
  
  Dim fso As New FileSystemObject
  
  If fso.FolderExists(sMyAlbums & sAlbumName) Then
  
    If fso.FileExists(sMyAlbums & sAlbumName & "\" & sAlbumName & ".aml") Then
    
      MsgBox GetFromINI("modGlobal", "CheckExst"), vbCritical, sAppName
      Exit Function
      
    End If
    
  Else
  
    On Error GoTo Error_CreateFolder
    fso.CreateFolder (sMyAlbums & sAlbumName)
    On Error GoTo Error_Handler
    
  End If
  
  CreateAlbumFolder = True
  Set fso = Nothing
  Exit Function
  
Error_Handler:
  HandleError Err, "modGlobal:CreateAlbumFolder", Erl
  Resume Next
  
Error_CreateFolder:
  MsgBox "Error creating folder '" & sMyAlbums & sAlbumName & "'.", vbCritical, sAppName
  Set fso = Nothing
  
End Function

'****************
'* CreateAlbum: *
'****************

Public Sub CreateAlbum(ByVal sAlbumName As String)

  On Error GoTo Error_Handler
  If sAlbumName = vbNullString Then Exit Sub
  SetAlbumSpecs
  
  Dim i     As Integer
  Dim oNew  As MSXML.IXMLDOMElement
  Dim oNew2 As MSXML.IXMLDOMElement
  
  Set oDOMAlbum = New MSXML.DOMDocument
  Set oNew = oDOMAlbum.createElement("ALBUM")
  sOrder = vbNullString
  oNew.setAttribute "ORDER", vbNullString
  oNew.setAttribute "VERSION", VERSION_NR
  oNew.setAttribute "PICCOUNT", vbNullString
  oNew.setAttribute "LASTMAP", frmMyPersonalStory.FT1.SelectedFolder
  oNew.setAttribute "LANG", sLanguage
  oNew.setAttribute "PARTNER", sPartner
  oNew.setAttribute "STORY", sStory
  oNew.setAttribute "GENDER", sGender
  oDOMAlbum.appendChild oNew.cloneNode(False)
  
  For i = 1 To iPages
  
    Set oNew = oDOMAlbum.createElement("PAGE")
    oNew.setAttribute "NR", i
    oDOMAlbum.documentElement.appendChild oNew.cloneNode(False)
    
  Next
  
  Dim oDOMTemplate As New MSXML.DOMDocument
  
  If DOMLoad(oDOMTemplate, App.Path & IIf(Right(App.Path, 1) = "\", vbNullString, "\") & sStoryDir & "\" & sStory & "\" & sStory & ".xml") Then
  
    oDOMAlbum.documentElement.setAttribute "CODE", oDOMTemplate.documentElement.getAttribute("CODE")
    
    For i = 1 To iPages
    
      For Each oNew In oDOMTemplate.documentElement.childNodes(i).childNodes
      
        If oNew.nodeName = "TEXT" Then
        
          If oNew.getAttribute("GENDER") = sGender Then
          
            oNew.Text = Replace(oNew.Text, "XXXXX", sPerson)
            oNew.Text = Replace(oNew.Text, "XXXX", sPerson)
            oDOMAlbum.documentElement.childNodes(i - 1).appendChild oNew
            
          End If
          
        Else
        
          oDOMAlbum.documentElement.childNodes(i - 1).appendChild oNew
          
        End If
        
      Next
      
    Next
    
    'Cover:
    Set oDOMCover = New MSXML.DOMDocument
    Set oNew = oDOMCover.createElement("COVER")
    oNew.setAttribute "PICCOUNT", vbNullString
    oDOMCover.appendChild oNew.cloneNode(False)
    Set oNew = oDOMCover.createElement("PAGE")
    oNew.setAttribute "NR", 1
    
    For Each oNew2 In oDOMTemplate.documentElement.childNodes(0).childNodes
    
      If oNew2.nodeName = "TEXT" Then
      
        If oNew2.getAttribute("GENDER") = sGender Then
        
          oNew2.Text = Replace(oNew2.Text, "XXXXX", sPerson)
          oNew2.Text = Replace(oNew2.Text, "XXXX", sPerson)
          oNew.appendChild oNew2
          
        End If
        
      Else
      
        oNew.appendChild oNew2
        
      End If
      
    Next
    
    oDOMCover.documentElement.appendChild oNew.cloneNode(True)
    
  End If
  
  Set oDOMTemplate = Nothing
  Set oNew2 = Nothing
  Set oNew = Nothing
  sAlbName = sAlbumName
  frmMyPersonalStory.SaveAlbum sMyAlbums & sAlbName & "\" & sAlbName & ".aml"
  UpdateCaption sMyAlbums & sAlbName & "\" & sAlbName & ".aml"
  frmMyPersonalStory.EmptyStack
  frmMyPersonalStory.CreatePageThumbs
  frmMyPersonalStory.optPage(1).Value = True
  iPage = 1
  frmMyPersonalStory.ArrangePages
  frmMyPersonalStory.IkThumb1.Refresh
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:CreateAlbum", Erl
  Resume Next
  
End Sub

Public Sub SetAlbumSpecs()

  On Error GoTo Error_Handler
  
  'Set all album specs:
  
  iPages = 21
'  iPages = 16
'  iPages = 8
  iMaxPics = 2
  iMaxTxts = 3
  
  'Set the constant page/cover width & height in mm and in twips:
  
  iPgWdMm = 214
  iPgHtMm = 152
  iPgWdTw = 7886
  iPgHtTw = 5620
'  iPgWdMm = 152
'  iPgHtMm = 214
'  iPgWdTw = 5620
'  iPgHtTw = 7886
  iCvrWdMm = 485
  iCvrHtMm = 184
  iCvrWdTw = 17873
  iCvrHtTw = 6781
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:SetAlbumSpecs", Erl
  Resume Next
  
End Sub

Public Sub UpdateCaption(sSource As String)

  On Error GoTo Error_Handler
  
  Dim fso As New FileSystemObject
  
  frmMyPersonalStory.Caption = sAppName & " - " & Left(fso.GetFileName(sSource), Len(fso.GetFileName(sSource)) - 4)
  Set fso = Nothing
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:UpdateCaption", Erl
  Resume Next
  
End Sub

'***************
'* ValidEmail: *
'***************

Public Function ValidEmail(ByVal sCheck As String) As Boolean

  Const sInvalidChars As String = "!#$%^&*()=+{}[]|\;:'/?>,< "
  
  Dim bCK     As Boolean
  Dim sDomain As String
  Dim i       As Integer

  'Check to see if there is a double quote:
  bCK = Not InStr(1, sCheck, Chr(34)) > 0
  If Not bCK Then GoTo ExitFunction
  
  'Check to see if there are consecutive dots:
  bCK = Not InStr(1, sCheck, "..") > 0
  If Not bCK Then GoTo ExitFunction
  
  'Check for invalid characters:
  If Len(sCheck) > Len(sInvalidChars) Then
    
    For i = 1 To Len(sInvalidChars)
        
      If InStr(sCheck, mid(sInvalidChars, i, 1)) > 0 Then
          
        bCK = False
        GoTo ExitFunction
      
      End If
    
    Next
  
  Else
    
    For i = 1 To Len(sCheck)
        
      If InStr(sInvalidChars, mid(sCheck, i, 1)) > 0 Then
          
        bCK = False
        GoTo ExitFunction
      
      End If
    
    Next
  
  End If
  
  'Check for an @ symbol:
  If InStr(1, sCheck, "@") > 1 Then
      
    bCK = Len(Left(sCheck, InStr(1, sCheck, "@") - 1)) > 0
  
  Else
      
    bCK = False
  
  End If
  
  If Not bCK Then GoTo ExitFunction
  
  'Check to see if there are too many @'s:
  sCheck = Right(sCheck, Len(sCheck) - InStr(1, sCheck, "@"))
  bCK = Not InStr(1, sCheck, "@") > 0
  If Not bCK Then GoTo ExitFunction
  
  sDomain = Right(sCheck, Len(sCheck) - InStr(1, sCheck, "."))
  bCK = Len(sDomain) > 0 And InStr(1, sCheck, ".") < Len(sCheck)
  If Not bCK Then GoTo ExitFunction
  
  sCheck = Left(sCheck, Len(sCheck) - Len(sDomain) - 1)
  
  Do Until InStr(1, sCheck, ".") <= 1
      
    If Len(sCheck) >= InStr(1, sCheck, ".") Then
        
      sCheck = Left(sCheck, Len(sCheck) - (InStr(1, sCheck, ".") - 1))
    
    Else
        
      bCK = False
      GoTo ExitFunction
    
    End If
  
  Loop
  
  If sCheck = "." Or Len(sCheck) = 0 Then bCK = False
  
ExitFunction:
  ValidEmail = bCK

End Function

'**************
'* Quicksort: *
'**************

Public Sub Quicksort(ByRef list() As String, ByVal Min As Long, ByVal Max As Long, Optional sFolder As String)

  Dim mid As String
  Dim hi  As Long
  Dim lo  As Long
  Dim i   As Long
  Dim fso As New FileSystemObject

  'If there is 0 or 1 item in the list, this sublist is sorted:
  If Min >= Max Then Exit Sub

  'Pick a dividing value:
  i = Int((Max - Min + 1) * Rnd + Min)
  mid = list(i)

  'Swap the dividing value to the front:
  list(i) = list(Min)
  
  lo = Min
  hi = Max
  
  Do
    
    'Look down from hi for a value < mid:
    
    If sFolder = vbNullString Then
    
      Do While list(hi) >= mid
      
        hi = hi - 1
        If hi <= lo Then Exit Do
      
      Loop
    
    Else
    
      Do While fso.GetFile(sFolder & IIf(Right(sFolder, 1) = "\", vbNullString, "\") & list(hi)).DateLastModified >= fso.GetFile(sFolder & IIf(Right(sFolder, 1) = "\", vbNullString, "\") & mid).DateLastModified
      
        hi = hi - 1
        If hi <= lo Then Exit Do
      
      Loop
      
    End If
    
    If hi <= lo Then
      
      list(lo) = mid
      Exit Do
    
    End If
  
    'Swap the lo and hi values:
    list(lo) = list(hi)
  
    'Look up from lo for a value >= mid:
    lo = lo + 1
    
    If sFolder = vbNullString Then
    
      Do While list(lo) < mid
      
        lo = lo + 1
        If lo >= hi Then Exit Do
      
      Loop
    
    Else
    
      Do While fso.GetFile(sFolder & IIf(Right(sFolder, 1) = "\", vbNullString, "\") & list(lo)).DateLastModified < fso.GetFile(sFolder & IIf(Right(sFolder, 1) = "\", vbNullString, "\") & mid).DateLastModified
      
        lo = lo + 1
        If lo >= hi Then Exit Do
      
      Loop
      
    End If
    
    If lo >= hi Then
    
      lo = hi
      list(hi) = mid
      Exit Do
    
    End If
  
    'sSwap the lo and hi values:
    list(hi) = list(lo)
  
  Loop
  
  Set fso = Nothing
  
  'Sort the two sublists recursively:
  Quicksort list, Min, lo - 1, sFolder
  Quicksort list, lo + 1, Max, sFolder

End Sub

'****************
'* HandleError: *
'****************

Public Sub HandleError(ByRef oErr As ErrObject, ByVal sWhere As String, ByVal lLine As Long)

  On Error GoTo Error_Handler
  
  If oDOMErrors.hasChildNodes = False Then
  
    Dim oElem As MSXML.IXMLDOMElement
    
    Set oDOMErrors = New MSXML.DOMDocument
    Set oElem = oDOMErrors.createElement("ERRORS")
    oDOMErrors.appendChild oElem.cloneNode(False)
    
    'Only report first error (possible following errors probably caused by system instability):
    
    Set oElem = oDOMErrors.createElement("ERROR")
    oElem.setAttribute "NUMBER", oErr.Number
    oElem.setAttribute "SUB", sWhere
    oElem.setAttribute "LINE", lLine
    oDOMErrors.documentElement.appendChild oElem.cloneNode(False)
    
    If CheckInternet = False Then
    
      Dim sRes As String
      
      sRes = HTTPRequest(frmMyPersonalStory.Inet1, WEB_REQUEST & "ACTION=CLIENTERROR&NUMBER=" & iWindowsVersion & "&SUB=" & sWhere & "&LINE=" & lLine & "&VERSION=" & VERSION_NR & "&LANG=" & sLanguage & "&PARTNER=" & sPartner)
      
    Else
    
      If oErr.Description <> vbNullString Then
      
        MsgBox "Error " & oErr.Number & " in " & sWhere & " on line " & lLine & vbCrLf & oErr.Description & vbCrLf & vbCrLf & "Please report this error to " & sAppMail & ".", vbCritical, sAppName
        
      Else
      
        MsgBox "Error " & oErr.Number & " in " & sWhere & " on line " & lLine & vbCrLf & vbCrLf & "Please report this error to " & sAppMail & ".", vbCritical, sAppName
        
      End If
      
    End If
    
    Set oElem = Nothing
    
  End If
  
  Exit Sub
  
Error_Handler:
  HandleError Err, "modGlobal:HandleError", Erl
  Resume Next
  
End Sub
